package com.myoa.engineering.crawl.ppomppu.processor.infrastructure.client;

import org.springframework.stereotype.Component;
import org.springframework.web.reactive.function.client.WebClient;

import com.myoa.engineering.crawl.ppomppu.processor.dto.constant.WebClientPropertiesUnitName;
import com.myoa.engineering.crawl.ppomppu.support.webclient.factory.WebClientFilterFactory;
import com.myoa.engineering.crawl.ppomppu.support.webclient.properties.WebClientProperties;
import com.myoa.engineering.crawl.ppomppu.support.webclient.properties.WebClientProperties.WebClientPropertiesUnit;

import lombok.extern.slf4j.Slf4j;

/**
 * PpomppuNotifierSenderAPIClient
 * @author Shin Woo-jin (woo-jin.shin@linecorp.com)
 * @since 2021-11-17
 *
 */
@Slf4j
@Component
public class SenderAPIClient {

    private final WebClient webClient;

    public SenderAPIClient(WebClientProperties webClientProperties) {
        WebClientPropertiesUnit webClientPropertiesUnit =
            webClientProperties.find(WebClientPropertiesUnitName.PPOMPPU_NOTIFIER_SENDER_API.getUnitName());
        this.webClient = WebClient.builder()
                                  .baseUrl(webClientPropertiesUnit.getBaseUrl())
                                  .filter(WebClientFilterFactory.logRequest())
                                  .filter(WebClientFilterFactory.logResponse())
                                  .build();
    }
}

// TODO webclient properties